# COMMAND TO EXECUTE THIS SCRIPT FILE WITH A PARSING TRACE FILE: awk -f <awk-script-filename.awk> <filename.tr>
#Output : performance.txt, delay_out.txt, throughput_out.txt, trafficload_out.txt, energy_consumption.txt  

function average (array) {
    sum = 0;
    items = 0;
    for (i in array) {
        sum += array[i];
        items++;
    }
    if (sum == 0 || items == 0)
        return 0;
    else
        return sum / items;
}

function max(array) {
    for (i in array) {
        if (array[i] > largest)
            largest = array[i];
    }
    return largest;
}

function min(array) {
    smallest = 0;
    for (i in array) {
        if (0 == smallest)
            smallest = array[i];
        else if (array[i] < smallest)
            smallest = array[i];
    }
    return smallest;
}

BEGIN {

printf("The sum on line %d\n", pkt_size);
    # Records the total traffic packets sent, received and dropped.
    total_AGTpackets_sent = 0;
    total_AGTpackets_received = 0;
    total_AGTpackets_dropped = 0;

    signal=0;
    
    no_of_nodes=7;    
    route_reqs=0;
    
    no_of_flows = 0;
    
    # FOR EACH MAC PKT TYPE: CM1, CM2, CM3, ...
    
    # Variables collecting individually each MAC packets (CM1, CM2, ...) sent, received or dropped.
    sent_MAC[11]=0;
    received_MAC[11]=0;
    dropped_MAC[11]=0;
    
    # Accumulated size of individual MAC packets (CM1, CM2, ...) sent, received and dropped.
    sent_MACsize[11]=0;
    received_MACsize[11]=0;
    dropped_MACsize[11]=0;
    
    # IRRESPECTIVE OF MAC PKT TYPE
    
    # Sum of the number of all MAC packets, irrespective of its type, sent, received and dropped.
    total_sent_MACpkts=0;
    total_received_MACpkts=0;
    total_dropped_MACpkts=0;
    
    # Sum of the size of all MAC packets, irrespective of its type, sent, received and dropped.
    total_sent_MACsize=0;
    total_received_MACsize=0;
    total_dropped_MACsize=0;
	 
    first_packet_sent = 0;
    last_packet_sent = 0;
    last_packet_received = 0;
    

	
	
}
{

  event = $1;
  time = $2;
  node = $3;
  event_level = $4;
  reason = $5;
  node2 = $5;
  packetid = $6;
  pack_type = $7;
  pack_size = $8;
  dest = $10;
  source = $11;
  energy = $14;

# strip leading and trailing _ from node
    sub(/^_*/, "", node);
    sub(/_*$/, "", node);
    
# strip trailing ] from the energy value
    sub(/]*$/, "", energy);
 
   if (time < simulation_start || simulation_start == 0)
	simulation_start = time;

   if (time > simulation_end)
	simulation_end = time;

   if (reason == "COL")
	total_collision++



# Check for a MAC packet
    if (event !="N")
    {
	if (event == "s")
	    {
                if (source == "a")
                    source = 10;
                else if (source == "b")
                    source = 11;		    
                else if (source == "c")
                    source = 12;
                else if (source == "d")
                    source = 13;
                else if (source == "e")
                    source = 14;
                else if (source == "f")
                    source = 15;
                else if (source == "10")
                    source = 16;
                else if (source == "11")
                    source = 17;
                else if (source == "12")
                    source = 18;
                else if (source == "13")
                    source = 19;
                else if (source == "14")
                    source = 20;
                else if (source == "15")
                    source = 21;
                else if (source == "16")
                    source = 22;
                else if (source == "17")
                    source = 23;
                else if (source == "18")
                    source = 24;
                else if (source == "19")
                    source = 25;
                else if (source == "1a")
                    source = 26;
                else if (source == "1b")
                    source = 27;
                else if (source == "1c")
                    source = 28;
                else if (source == "1d")
                    source = 29;
                else if (source == "1e")
                    source = 30;
                else
                    source = source;

                if (dest == "a")
                    dest = 10;
                else if (dest == "b")
                    dest = 11;
                else if (dest == "c")
                    dest = 12;
                else if (dest == "d")
                    dest = 13;
                else if (dest == "e")
                    dest = 14;
                else if (dest == "f")
                    dest = 15;
                else if (dest == "10")
                    dest = 16;
                else if (dest == "11")
                    dest = 17;
                else if (dest == "12")
                    dest = 18;
                else if (dest == "13")
                    dest = 19;
                else if (dest == "14")
                    dest = 20;
                else if (dest == "15")
                    dest = 21;
                else if (dest == "16")
                    dest = 22;
                else if (dest == "17")
                    dest = 23;
                else if (dest == "18")
                    dest = 24;
                else if (dest == "19")
                    dest = 25;
                else if (dest == "1a")
                    dest = 26;
                else if (dest == "1b")
                    dest = 27;
                else if (dest == "1c")
                    dest = 28;
                else if (dest == "1d")
                    dest = 29;
                else if (dest == "1e")
                    dest = 30;
                else
                    dest = dest;


  		# The number of flows in the network, irrespective if the transmitted packets are received or not !!
                if ((pack_type=="exp"||pack_type=="cbr") && dest != "ffffffff")
                    {
                        if (no_of_flows == 0 && (source!=dest) && (source==0 || dest==0))
                        {
                            sources[no_of_flows] = source;
                            dests[no_of_flows] = dest;
			    #printf("*%s\n", $0);
			    #printf("***%d\n",sources[dadad] );
			    
                            no_of_flows++;
		            #printf("*%d\n", no_of_flows);
                        }
                        else
                        {
                            flag = 1;
                            i = 0;

                            while (i<no_of_flows && (source!=dest) && (source==0 || dest==0))
                                {
                                    if (!(sources[i]==source && dests[i]==dest))
                                        {
                                            #printf ("%d-%d :: %d :: %d-%d\n", source, dest, i, sources[i], dests[i]);
                                            #if (source == 3 && dest == 0)
                                            #printf("*%s*\n", $0);
                                            flag = 0;
                                        }
                                    else
                                        {
                                            flag = 1;
                                            break;
                                        }
                                    i++;
				   
                                }

                            if (flag != 1)
                                {
                                    sources[no_of_flows] = source;
				    #printf("*%s\n", $0);
				    #printf("sources[no_of_flows]: %d\n",sources[no_of_flows] );
                                    dests[no_of_flows] = dest;
				    #printf("dests[no_of_flows]: %d\n",dests[no_of_flows] );
				
                                    no_of_flows++;
				    #printf("Flows : %d\n", no_of_flows);
                                }
                        }

                        if ((source!=dest) && (source==0 || dest==0))
                            {
                                for (z=0; z<no_of_flows; z++)
                                    {
                                        if (sources[z]==source && dests[z]==dest)
                                            csma_analyze[z]++;
					    #printf("*%s*\n", $0);
					    #printf("*%d--%d\n", sources[z],dests[z]);
					    #printf("*%d*\n", csma_analyze[z]);
                                    }
				
                            }
                    }
	    }

  	if (energy_flag[node]==0)
	    {
			
		initial_energy[node]=energy;
		energy_flag[node]=1;	
		
	    }	
	else 
	    {
		energy_used[node]=initial_energy[node]-energy;
		percent_energy_used[node] = (energy_used[node]*100)/initial_energy[node];
		#printf("Prosentase Energy Used : %f*\n", percent_energy_used[node]);
		
	    }
       

	#if (node > no_of_nodes)
	#    no_of_nodes = node;
	
	if (pack_type=="AODV" && event_level!="MAC")
	    route_reqs++;
	    
	if (event_level == "MAC")
	    {
		# Check for the packet types: CM1, CM2, CM3, ...etc
		if (pack_type == "CM1")
		    signal = 1;
		else if (pack_type == "CM2")
		    signal = 2;
		else if (pack_type == "CM3")
		    signal = 3;
		else if (pack_type == "CM4")
		    signal = 4;
		else if (pack_type == "CM5")
		    signal = 5;
		else if (pack_type == "CM6")
		    signal = 6;
		else if (pack_type == "CM7")
		    signal = 7;
		else if (pack_type == "CM8")
		    signal = 8;
		else if (pack_type == "CM9")
		    signal = 9;
		else if (pack_type == "BCN")
		    signal = 10;
		else if (pack_type == "ACK")
		    signal = 11;
		else
		    signal = 0;
	
		# Based on packet type (signal, here) accumulate corresponding variables of the MAC variable arrays.
		if (signal)
		    {
			if (event == "s")
			    {
				sent_MAC[signal] += 1;
				#printf("*%s \n",$0);
 				#printf("Total sent MAC[BCN]: %d \n",sent_MAC[signal]);
				sent_MACsize[signal] = pack_size + sent_MACsize[signal];
			        #printf("Total sent MACSize[signal]: %d \n",sent_MACsize[signal]);
			    }

			else if (event == "r")
			    {
				received_MAC[signal] += 1;
				received_MACsize[signal] = pack_size + received_MACsize[signal];
			    }

			else if (event == "D")
			    {
				dropped_MAC[signal] += 1;
				#printf("*%s \n",$0);
 				#printf("Total Drop MAC[signal]: %d \n\n",dropped_MAC[signal]);
				dropped_MACsize[signal] = pack_size + dropped_MACsize[signal];
			    }
		    }
	    }
    }

    else if(event == "N")
	{
	    #if (node2 > no_of_nodes)
		#no_of_nodes = node2;
	
	    if (energy_flag[node2]==0)
		{
    		    # Note that because the energy entries in the trace file alters the previously established format, 
		    # we extract energy entries where we previously used to have the mac_sub_type. 
		    #pack_type $7 in here is energy 
	
		    initial_energy[node2] = pack_type;
		    energy_flag[node2] = 1;
		}
	    else
		{
		    energy_used[node2] = initial_energy[node2] - pack_type;    
		    percent_energy_used[node2] = (energy_used[node2]*100)/initial_energy[node2];
		}
	}
    
      
    

    if ( event_level == "MAC"  && (pack_type == "exp" || pack_type == "cbr"))
	{
	    nodes[node] = node; 		# Count number of nodes 
	    #printf("%s \n", $0);
	
    	    if ( time < node_start_time[node] || node_start_time[node] == 0 )
        	node_start_time[node] = time;

    	    if ( time > node_end_time[node] )
        	node_end_time[node] = time;

    	    if ( event == "s" )
		{
			
        	    if ( time < first_packet_sent || first_packet_sent == 0 )
			{            		
			first_packet_sent = time;
			#printf("first packet sent : %s \n", $0);
			}
        	    if ( time > last_packet_sent )
			{            		
			last_packet_sent = time;
			#printf("last packet sent : %s \n", $0);
			}
        	    # rate
        	    packets_sent[node]++;
        	    total_AGTpackets_sent++;

        	    # delay
        	    pkt_start_time[packetid] = time;
    		}
    	    else if ( event == "r" ) 
		{
        	    if ( time > last_packet_received )
            		last_packet_received = time;
        	    
		    # throughput
        	    packets_received[node]++;
        	    total_AGTpackets_received++;

        	    # delay
        	    pkt_end_time[packetid] = time;
    		}
    	    else if ( event == "D" ) 
		{
        	    total_AGTpackets_dropped++;
		    #printf("%s \n", $0);
    		}
	}
  
    #check flows packets cbr from a source node to a dest node
    #if (event == "s" && node == "13"   && source == "13"  && dest == "0" && pack_type == "cbr")
    #   { printf("*%s\n", $0); }
    # printf ("nodes : %d", no_of_nodes)

    #iteration total energy used by a node
    #if (node == "0")
    #   {
    #    printf("Energy User ==> %f      = %f   - %f\n", energy_used[0],initial_energy[0],energy);
    #	printf("Percentage Energy Used ==> %f      = %f   / %f\n",percent_energy_used[0],energy_used[0]*100,initial_energy[0] );
    #   }

}
END {
#printf("node_start_time[node-1] : %f \n",node_start_time[1]);
#printf("node_end_time[node-1] : %f \n",node_end_time[1]);
#printf("First Packet Sent Time at Level AGT : %f \n",first_packet_sent);
#printf("Last Packet Sent Time at Level AGT : %f \n",last_packet_sent);
#printf("Last Packet Received Time at Level AGT : %f \n",last_packet_received);
#printf("Number of Packet sent at[node-0] : %d \n",packets_sent[0]);
#printf("Number of Packet sent at[node-1] : %d \n",packets_sent[1]);
#printf("Number of Packet sent at[node-2] : %d \n",packets_sent[2]);
#printf("Number of Received  at[node-0] : %d \n",packets_received[0]);
#printf("Number of Received  at[node-1] : %d \n",packets_received[1]);
#printf("Number of Received  at[node-2] : %d \n",packets_received[2]);
#printf("Number of Received  at[node-3] : %d \n",packets_received[3]);
#printf("Number of Received  at[node-4] : %d \n",packets_received[4]);
#printf("Number of Received  at[node-5] : %d \n",packets_received[5]);
#printf("Number of Received  at[node-6] : %d \n",packets_received[6]);
#printf("Number of Received  at[node-7] : %d \n",packets_received[7]);
#printf("Number of Received  at[node-8] : %d \n",packets_received[8]);
#printf("Number of Received  at[node-9] : %d \n",packets_received[9]);
#printf("Number of Received  at[node-10] : %d \n",packets_received[10]);
#printf("Number of Received  at[node-11] : %d \n",packets_received[11]);
#printf("Number of Received  at[node-12] : %d \n",packets_received[12]);
#printf("Number of Received  at[node-13] : %d \n",packets_received[13]);
#printf("Total Packet sent at Level AGT : %d \n",total_AGTpackets_sent);
#printf("Total Packet received at Level AGT : %d \n",total_AGTpackets_received);
#printf("Total Packet dropped at Level AGT : %d \n",total_AGTpackets_dropped);
#printf("start time packet ID-1 : %f \n",pkt_start_time[1]);
#printf("received time packet ID-1 : %f \n",pkt_end_time[1]);
#printf("delay time packet ID-1 : %f \n",pkt_end_time[1]-pkt_start_time[1]);
#printf("start time packet ID-588 : %f \n",pkt_start_time[588]);
#printf("received time packet ID-588 : %f \n",pkt_end_time[588]);
#printf("delay time packet ID-588 : %f \n",pkt_end_time[588]-pkt_start_time[588]);



#    for (i in flows)
#       {
#	    #printf ("this i: %d\n", i);
#	    no_of_flows++;
#	}

#    printf("no_of_flows: %d\n", no_of_flows);
    
#    for (q=0; q<no_of_flows; q++)
#    	printf ("%d - %d\n", sources[q], dests[q]);

#**************************** find dropped packets*******************
    if ( total_AGTpackets_sent != total_AGTpackets_received ) 
    	{
    	    for ( packetid in pkt_start_time ) 
    		{
    		    if (0 == pkt_end_time[packetid])
	
            		total_AGTpackets_dropped++;
    		}
    	}

#****************************throughput calculation*******************
    for (i in nodes) 
    	{
    	    if ( packets_received[i] > 0 ) 
    		{
        	    end = node_end_time[i];
        	    start = node_start_time[i];
        	    runtime = end - start;
		    #printf("%s\n", $0);
        	    if ( runtime > 0 ) 
    			{
            		    throughput[i] = packets_received[i]*pkt_size*8/ runtime;
			    throughput2[i] = packets_received[i]*pkt_size*8/ runtime;
    			    #printf("%d %f %f %d\n", i, start, end, throughput[i]);
			    
        		}
		   
    		}
	    
            
    	
    	    # rate - not very accurate
    	    if ( packets_sent[i] > 2 ) 
    		{
        	    end = node_end_time[i];
        	    start = node_start_time[i];
        	    runtime = end - start;
		    if ( runtime > 0 ) 
		       {
        	    	rate[i] = (packets_sent[i]*pkt_size*8) / runtime;
		        rate2[i] = (packets_sent[i]*pkt_size*8) / runtime;
			#printf("%d %d %f %f %d\n", i, packets_sent[i], start, end, rate[i]);
		       }
    		}
    	}

#****************DELAY EVERY PACKET ID, MIN, MAX, AVERAGE DELAY*******************
#printf("Delay every Packet ID (cbr), min, max and average delay\n")>> "delay_out.txt";
#printf("Pakcet ID | Packet Start Time | Packet End Time | Delay \n")>> "delay_out.txt";
#printf("-------------------------------------------------------\n\n")>> "delay_out.txt";
    # delay
    for ( pkt in pkt_end_time) 
    {
        end = pkt_end_time[pkt];
        start = pkt_start_time[pkt];
        delta = end - start;
        if ( delta > 0 ) 
            delay[pkt] = delta;
#	    printf("%d         %f       %f    %f\n", pkt, start, end,delay[pkt])>> "delay_out.txt";
    }
 printf("\n\nMin Delay : %f \nMax Delay : %f \nAverage Delay : %f ", 
           min(delay),
           max(delay),
           average(delay)) >> "delay_out.txt";

#***********TRAFFIC LOAD*****************
    # offered load
    total_runtime = last_packet_sent - first_packet_sent;
    if ( total_runtime > 0 && total_AGTpackets_sent > 0)
        {
         load = ((total_AGTpackets_sent * pkt_size*8)/total_runtime) ; # n=o overhead
         load1 = (total_AGTpackets_sent / total_runtime);
        } 
    printf("Load = (Total CBR Packets sent at level MAC  * Size in Bytes * 8) / Run Time bps\n")>> "trafficload_out.txt";
    printf("Load1 = (Total CBR Packets sent at level MAC) / Run Time packets/sec \n\n")>> "trafficload_out.txt";
    printf("Last Packet Sent Time : %f\n",last_packet_sent)>> "trafficload_out.txt";
    printf("First Packet Sent Time : %f\n",first_packet_sent)>> "trafficload_out.txt";
    printf("Total Runtime : %f\n",total_runtime)>> "trafficload_out.txt";
    printf("Total AGTPackets sent : %d\n",total_AGTpackets_sent)>> "trafficload_out.txt";
    printf("Traffic Load : %f bps\n", load)>> "trafficload_out.txt";
    printf("Traffic Load : %f packets/sec\n\n", load1)>> "trafficload_out.txt";

#***********************
    printf("\n\nAverage Throughput : %d \n Min Delay : %f Max Delay : %f Average Delay : %f ", 
           average(throughput),
           min(delay),
           max(delay),
           average(delay)) >> "performance.txt";

#****************Total packet sent and received by every node*******************
printf("Total CBR packets sent, total packets received, Througput and Rate by every node at Level MAC\n") >> "throughput_out.txt";
printf("Node   |  Packet Sent (item)| Packet Received (item) | Node Start Time | Node End Time | Throughput (bps) | Rate (bps)\n")>> "throughput_out.txt";
printf("----------------------------------------------------------------------------------------------------------------------\n")>> "throughput_out.txt";
for (i=0; i<no_of_nodes; i++)
 {  
  printf(" %d        %d                    %d                      %f                %f                 %d        %d\n",i, packets_sent[i],packets_received[i],node_start_time[i],node_end_time[i],throughput[i],rate[i] )>> "throughput_out.txt";
 }

printf("\n\nAverage Throughput (Total Throughput / Number of Nodes that received packets) : %d \nAverage Rate (Total Rate / Number of Nodes that sent packets) : %d ", 
           average(throughput2),
           average(rate2)) >> "throughput_out.txt";


#********************Total packets and packets size for event Level MAC : CM1, CM2,..BCN,ACK.***********
printf("*** Analyze MAC Packets***\n") >> "mac_packets.txt";
printf("*** NOTE : 1=CM1; 2=CM2; 3=CM3; 4=CM4; 5=CM5; 6=CM6; 7=CM7; 8=CM8; 9=CM9; 10=BCN; 11=ACK\n\n") >> "mac_packets.txt";
printf("Signal |Sent MACPkts | Received MACPkts |Dropped MACPkts | Sent MACSize | Received MACSize  | Dropped MACSize \n") >> "mac_packets.txt" ;
printf("----------------------------------------------------------------------\n") >> "mac_packets.txt";

     for (i=1; i<=11; i++)
	{
	   
	    total_sent_MACpkts = total_sent_MACpkts + sent_MAC[i];
	    total_received_MACpkts = total_received_MACpkts + received_MAC[i];
	    total_dropped_MACpkts = total_dropped_MACpkts + dropped_MAC[i];

	    total_sent_MACsize = total_sent_MACsize + sent_MACsize[i];
	    total_received_MACsize = total_received_MACsize + received_MACsize[i];    
	    total_dropped_MACsize = total_dropped_MACsize + dropped_MACsize[i];	

printf(" %d          %d            %d              %d                %d               %d               %d      \n", i, sent_MAC[i], received_MAC[i], dropped_MAC[i], sent_MACsize[i], received_MACsize[i], dropped_MACsize[i]) >> "mac_packets.txt";

	}

printf("----------------------------------------------------------------------\n") >> "mac_packets.txt";
printf("Total sent MACpkts : %d \nTotal Received MACpkts : %d \nTotal Dropped MACpkts : %d \nTotal Sent MACSize : %d \nTotal Received MACSize : %d\nTotal Dropped MACSize : %d     \n",total_sent_MACpkts, total_received_MACpkts, total_dropped_MACpkts,total_sent_MACsize,total_received_MACsize,total_dropped_MACsize )  >> "mac_packets.txt";
   
#***************************************************************   
    if (total_AGTpackets_sent != 0)
	pkt_delivery_ratio = (total_AGTpackets_received*100)/total_AGTpackets_sent;
	pkt_drop_ratio = (total_AGTpackets_dropped*100)/total_AGTpackets_sent;
    
    printf("\nTotal AGT packets sent : %d \nTotal AGT packets received : %d \nTotal AGT packets dropped : %d \nPackets delivery ratio : %f ", 
	   total_AGTpackets_sent,
	   total_AGTpackets_received,
	   total_AGTpackets_dropped,
	   pkt_delivery_ratio) >> "performance.txt";

printf("**** Packet Delivery Ratio = (Total AGT packets received * 100) / Total AGT packets sent)")>> "throughput_out.txt";
printf("\nTotal AGT packets sent : %d \nTotal AGT packets received : %d \nTotal AGT packets dropped : %d \nPackets delivery ratio : %f \nPackets dropped ratio : %f", 
	   total_AGTpackets_sent,
	   total_AGTpackets_received,
	   total_AGTpackets_dropped,
	   pkt_delivery_ratio,
	   pkt_drop_ratio) >> "throughput_out.txt";

  
#    ************** Node Energy Consumption **************** 
	    printf("*** Energy Consumption Detail ***\n\n") >> "energy_consumption.txt";
	    printf("Number of Nodes : %d\n\n", no_of_nodes) >> "energy_consumption.txt";
	    printf("Node |Initial Energy      |  Energy Used         | Percent energy Used\n") >> "energy_consumption.txt" ;
	    printf("----------------------------------------------------------------------\n") >> "energy_consumption.txt";
            printf(" 0   %f           %f               %f     \n", initial_energy[0], energy_used[0],percent_energy_used[0]) >> "energy_consumption.txt";
    for (i=0; i<no_of_nodes-1; i++)
	{
	    
	    initial_energy[0] = initial_energy[0]+initial_energy[i+1];
	    energy_used[0] = energy_used[0] + energy_used[i+1];
	    percent_energy_used[0] = percent_energy_used[0] + percent_energy_used[i+1];
	    
	    printf(" %d     %f           %f               %f     \n", i+1,initial_energy[i+1], energy_used[i+1],percent_energy_used[i+1]   ) >> "energy_consumption.txt";

	}
	    printf("----------------------------------------------------------------------\n") >> "energy_consumption.txt";
            printf("Total: %f           %f               %f     \n\n", initial_energy[0], energy_used[0],percent_energy_used[0]) >> "energy_consumption.txt";
    
    avg_initial_energy= initial_energy[0]/no_of_nodes;
    avg_energy_used= energy_used[0]/no_of_nodes;
    avg_percent_energy_used = percent_energy_used[0]/no_of_nodes;

            printf("Initial Energy = Total Initial Energy / Number of Nodes = %f / %d = %f\n", initial_energy[0], no_of_nodes, avg_initial_energy  ) >> "energy_consumption.txt";
	    printf("Energy Used = Total  Energy Used / Number of Nodes = %f / %d = %f\n", energy_used[0], no_of_nodes, avg_energy_used  ) >> "energy_consumption.txt";
	    printf("Percentage Energy Used = Total Energy Used / Number of Nodes = %f / %d = %f\n", percent_energy_used[0], no_of_nodes, avg_percent_energy_used  ) >> "energy_consumption.txt";

#****************************************************************************************    
    printf("\nInitial energy : %f \nEnergy Used : %f \nPercent Energy Used : %f \nMax(csma analyze) : %d \nMin(csma analyze) : %d \nMax(csma analyze)-Min(csma analyze) : %d \nMax(csma analyze)/Min(csma analyze): %f  ", 
	   avg_initial_energy,
	   avg_energy_used,
	   avg_percent_energy_used, 
	   max(csma_analyze),
	   min(csma_analyze),
	   max(csma_analyze)-min(csma_analyze),
	   max(csma_analyze)/min(csma_analyze)) >> "performance.txt";
    

	printf("\n\nTotal Collision : %d \nNumber of Flows : %d \nNumber of Route Request : %d", total_collision,no_of_flows, route_reqs) >> "performance.txt";

 	
}


